"""Add subject table

Revision ID: a69dfec6b6c5
Revises: 09d662433ed7
Create Date: 2023-07-30 20:09:41.661790

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "a69dfec6b6c5"
down_revision = "09d662433ed7"
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "subject",
        sa.Column(
            "subject_id",
            sa.String(length=4),
            nullable=False,
            comment="Subject code, e.g. COMP.",
        ),
        sa.Column(
            "name",
            sa.String(length=100),
            nullable=True,
            comment="Subject name.",
        ),
        sa.PrimaryKeyConstraint("subject_id"),
        comment="Subjects.",
    )
    op.alter_column(
        "course",
        "subject_id",
        existing_type=sa.VARCHAR(),
        comment=None,
        existing_comment="Subject code, e.g. COMP.",
        existing_nullable=False,
    )
    op.create_foreign_key(
        "course_subject_id_fkey", "course", "subject", ["subject_id"], ["subject_id"]
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint("course_subject_id_fkey", "course", type_="foreignkey")
    op.alter_column(
        "course",
        "subject_id",
        existing_type=sa.VARCHAR(),
        comment="Subject code, e.g. COMP.",
        existing_nullable=False,
    )
    op.drop_table("subject")
    # ### end Alembic commands ###
